;;;;---------------------------------------------------------------------------
;;;;
;;;;                      Ein left-corner Recognizer
;;;;
;;;;                           (breadth-first)
;;;;
;;;;---------------------------------------------------------------------------

;;;; File : lc-1.lsp

;;;; Waehle eine geeignete Syntax und ein geeignetes Lexikon:
(use :syntax syntax6 :lexikon lexikon6)


(defun recognize_lc (stack1 &optional (stack2 `(,(startsymbol))) stack3)
;  (format t "s1: ~a   s2: ~a   s3: ~a~%" stack1 stack2 stack3)
;  (read-line)
  (if (and (endp stack1) (endp stack2) (endp stack3))
      (print t)
      (dolist (x (append (lc-reduce stack1 stack2 stack3)
		     	 (move stack1 stack2 stack3)
		     	 (remove stack1 stack2 stack3)))
      	(apply #'recognize_lc x))))


(defun lc-reduce (stack1 stack2 stack3)
  (unless (eq (first stack2) t)
  	  (let ((resultat nil))
      	    (dolist (x (left-corner-rules (first stack1)) resultat)
  	      (setf resultat
		    (cons (list (rest stack1)
				(append (nthcdr 2 x) (cons t stack2))
				(cons (first x) stack3))
			  resultat))))))

(defun move (stack1 stack2 stack3)
  (when (and (eq (first stack2) t) (not (endp stack3)))
      	(list (list (cons (first stack3) stack1)
		    (rest stack2)
		    (rest stack3)))))

(defun remove (stack1 stack2 stack3)
  (when (eq (first stack1) (first stack2))
  	(list (list (rest stack1)
   	      	    (rest stack2)
	      	    stack3))))


(defun left-corner-rules (symbol)
  (or
   ;; wenn SYMBOL ein terminales Symbol ist, dann alle lexikalische Kategorien
   (rest (lexikon-eintrag symbol))
   ;; sonst alle Regeln mit 'left-corner' = SYMBOL
   (apply #'append (mapcar #'(lambda (x)	
			       (when (eq symbol (second x)) (list x)))
			   (regeln)))))
