;;;;---------------------------------------------------------------------------
;;;;
;;;;                     Ein left-corner Parser
;;;;
;;;;                        (breadth-first)
;;;;
;;;;---------------------------------------------------------------------------

;;;; File : lc-2.lsp

;;;; Waehle eine geeignete Syntax und ein geeignetes Lexikon:
(use :syntax syntax6 :lexikon lexikon6)


(defun parse_lc (stack1 &optional (stack2 `(,(startsymbol))) stack3 stack4)
;  (format t "~a    ~a    ~a    ~a~%" stack1 stack2 stack3 stack4)
;  (read-line)
  (if (and (endp stack1) (endp stack2) (endp stack3))
      (print (first stack4))
      (dolist (x (append (lc-reduce  stack1 stack2 stack3 stack4)
		     	 (move stack1 stack2 stack3 stack4)
		     	 (remove stack1 stack2 stack3 stack4)))
      	(apply #'parse_lc x))))



(defun lc-reduce (stack1 stack2 stack3 stack4)
  (unless (eq (first stack2) t)
  	  (let ((resultat nil))
      	    (dolist (x (left-corner-rules (first stack1)) resultat)
  	      (setf resultat
		    (cons (list (rest stack1)
				(append (nthcdr 2 x) (cons t stack2))
				(cons (first x) stack3)
				(if (eq (first stack1) (first (first stack4)))
				    (cons (list (first x) (first stack4))
					  (rest stack4))
	    			    (cons (list (first x) (first stack1))
					  stack4)))
	      		  resultat))))))


(defun move (stack1 stack2 stack3 stack4)
  (when (and (eq (first stack2) t) (not (endp stack3)))
      	(list (list (cons (first stack3) stack1)
		    (rest stack2)
		    (rest stack3)
		    stack4))))
 
(defun remove (stack1 stack2 stack3 stack4)
  (when (eq (first stack1) (first stack2))
  	(list (list (rest stack1)
   	      	    (rest stack2)
	      	    stack3
	      	    (if stack3
	    	  	(cons (append (second stack4) (list (first stack4)))
		  	      (nthcdr 2 stack4))
	    	  	stack4)))))


(defun left-corner-rules (symbol)
  (or
   ;; wenn SYMBOL ein terminales Symbol ist, dann alle lexikalische Kategorien
   (rest (lexikon-eintrag symbol))
   ;; sonst alle Regeln mit 'left-corner' = SYMBOL
   (apply #'append (mapcar #'(lambda (x)	
			       (when (eq symbol (second x)) (list x)))
			   (regeln)))))





