;-----------------------------------------------------------------------------
;
;                        Ein einfacher top-down Parser
;                               breadth-first
;                                   fuer
;                           Programmierte Syntaxen
;
;------------------------------------------------------------------------------


;;;;                   INFOS & INITIALISIERUNG
;;;;                   -----------------------

;;;; File : prog-p-1.lsp
;;;; letzte Aenderung: 07.10.93
;;;; der Parser generiert alle Strukturbeschreibungen fuer den Satz
;     ;;;; Waehle eine geeignete Syntax und ein geeignetes Lexikon:
;    (use :syntax syntax11 :lexikon lexikon1)

;;;; Lade (wenn noetig) die zur Strukturgenerierung notwendigen 
;;;; Funktionen:
(unless (fboundp 'transform)
   (lade-datei "td-tools.lsp"))





;;;;                        PROGRAMM
;;;;                        --------



(defun parse-td/bf (satz &optional (ableitung `(,(startsymbol)))
				   (indices (gethash (startsymbol) *vn*))
				   struktur)
  (cond ((and (endp satz) (endp ableitung)) struktur);(transform struktur))
        ((or (> (length ableitung) (length satz))
	     (endp ableitung) (endp satz) (endp indices)) nil)
        (t (dolist (x (get-rules indices) (values))
             (print
              (apply #'parse-td/bf
                     (reduziere-bf* satz
				    (ersetze ableitung (first x))
				    (second x))))))))


(defun reduziere-bf* (satz ablstruktur indices)
  (if (and (not (endp satz)) (equal (first satz) (first (first ablstruktur))))
      (reduziere-bf* (rest satz)
		     (list (rest (first ablstruktur)) (second ablstruktur))
		     indices)
     `(,satz ,(first ablstruktur) ,indices ,(second ablstruktur))))
  

(defun ersetze (ableitung regel)
  (let ((resultat nil)
	(reste (rest ableitung)))
    (dolist (x ableitung)
      (if (equal x (first regel))
	  (return (list (append resultat (rest regel) reste)
			(append resultat (list (first regel) (rest regel))) reste))
	  (setq resultat (append resultat (list x))
		reste (rest reste))))))
