;-----------------------------------------------------------------------------
;
;                      Ein einfacher top-down Recognizer
;                               breadth-first
;                                   fuer
;                           Programmierte Syntaxen
;
;------------------------------------------------------------------------------

;;;; File : prog-r-1.lsp
;;;; letzte Aenderung: 07.10.93
;;;; untersucht alle Ableitungsmoeglichkeiten fuer einen Satz
;     ;;;; Waehle eine geeignete Syntax und ein geeignetes Lexikon:
;     (use :syntax syntax11 :lexikon lexikon1)


(defun recognize-td/bf (satz &optional (ableitung `(,(startsymbol))) 
			               (indices (gethash (startsymbol) *vn*)))
  (cond ((and (endp satz) (endp ableitung)) t)
        ((or (> (length ableitung) (length satz))
	     (endp ableitung) (endp satz) (endp indices)) nil)
        (t (dolist (x (get-rules indices) (values))
	     (when
	       (apply #'recognize-td/bf
		      (reduziere-bf satz 
				    (ersetze ableitung (first x))
				    (second x)))
	       (print t))))))


(defun reduziere-bf (satz ableitung indices)
  (if (and (not (endp satz)) (equal (first satz) (first ableitung)))
      (reduziere-bf (rest satz) (rest ableitung) indices)
      (list satz ableitung indices)))


(defun ersetze (ableitung regel)
  (let ((resultat nil)
	(reste (rest ableitung)))
    (dolist (x ableitung)
      (if (equal x (first regel))
	  (return (append resultat (rest regel) reste))
	  (setq resultat (append resultat (list x))
		reste (rest reste))))))

(defun get-rules (indices)
  (mapcar #'(lambda (x)
	      (list (aref  *rules* 0 x)
		    (aref  *rules* 1 x)))
	  indices))
	  
;-----------------------------------------------------------------------------
;;;
;;;                 Daten
;;;
;;; Syntax & Lexikon fuer L = an bn cn
;;;

(setf *vn* (make-hash-table)
      (gethash 'S *vn*) '(1)
      (gethash 'X *vn*) '(2 5)
      (gethash 'Y *vn*)  '(3 6)
      (gethash 'Z *vn*)  '(4 7))

(setf *rules* (make-array '(2 10) 
			  :initial-contents 
			  '((7 (S X Y Z) (X a X) (Y b Y) (Z c Z) 
			       (X a) (Y b) (Z c) nil nil)
			    ((1 2 3 4 5 6 7) (2 5) (3) (4) (2 5) 
			     (6) (7) () nil nil))
			  ))
(setq *syntax*  `(,*vn* (a b c) S ,*rules*))



