;------------------------------------------------------------------------------
;
;                    Ein einfacher top-down Recognizer
;                             mit Backtracking
;
;----------------------------------------------------------------------------- 

;;;; File :  td-2.lsp
;;;; letzte Aenderung 29.6.92
;;;; Waehle eine geeignete Syntax und ein geeignetes Lexikon:
(use :syntax syntax11 :lexikon lexikon1)



(defun recognize-td/df (satz &optional (symbol `(,(startsymbol))))
  (let ((wort 0) (ableitung symbol) (stack ()))
    (declare (special wort))
    (loop
     (show-information :wort wort :ableitung ableitung :stack stack :satz satz)
     (if (and (= wort (length satz)) (endp ableitung))
	 (return t))
     (if (or (endp ableitung) (lexkat-p (first ableitung)))
	 (if (endp stack)
	     (return nil)
	     (let ((backtrack-werte (backtrack stack satz)))
	       (setq stack     (first backtrack-werte)
		     ableitung (second backtrack-werte))))
	 (let ((ex/re-werte (expandiere-reduziere ableitung stack satz)))
	   (setq stack     (first  ex/re-werte)
		 ableitung (second ex/re-werte)))))))



(defun expandiere-reduziere (ableitung stack satz)
  (declare (special wort))
  (format t "Expandiere und reduziere ...~%")
  (let ((regelseiten (expansionen (first ableitung))))
    (when regelseiten
      (if (endp (rest regelseiten))
	  (list stack
	        (reduziere (append (first regelseiten) (rest ableitung))
			   (nthcdr wort satz)))
	  (list (cons (list wort ableitung (rest regelseiten)) stack)
		(reduziere (append (first regelseiten) (rest ableitung))
			   (nthcdr wort satz)))))))
		

(defun backtrack (stack satz)
  (declare (special wort))
  (format t "Backtracking ...~%")
  (setq wort (first (first stack)))
  (list (if (endp (rest (third (first stack))))
	    (rest stack)
	    (subst (rest (third (first stack))) (third (first stack)) stack))
	(reduziere (append (first (third (first stack)))
			   (rest (second (first stack))))
		   (nthcdr wort satz))))


(defun reduziere (ableitung satz)
  (declare (special wort))
  (cond ((element_von-p (first satz) (first ableitung))
	 (setq wort (+ wort 1))
	 (reduziere (rest ableitung) (rest satz)))
	(t ableitung)))


