;-----------------------------------------------------------------------------
;
;                        Ein einfacher top-down Parser
;                               breadth-first
;
;------------------------------------------------------------------------------


;;;;                   INFOS & INITIALISIERUNG
;;;;                   -----------------------

;;;; File : td-5.lsp
;;;; letzte Aenderung: 29.6.92
;;;; der Parser generiert alle Strukturbeschreibungen fuer den Satz
;;;; Waehle eine geeignete Syntax und ein geeignetes Lexikon:
(use :syntax syntax11 :lexikon lexikon1)

;;;; Lade (wenn noetig) die zur Strukturgenerierung notwendigen 
;;;; Funktionen:
(unless (fboundp 'transform)
   (lade-datei "td-tools.lsp"))





;;;;                        PROGRAMM
;;;;                        --------



(defun parse-td/bf (satz &optional (ableitung `(,(startsymbol))) struktur)
  (cond ((and (endp satz) (endp ableitung)) (transform struktur))
        ((or (endp ableitung) (lexkat-p (first ableitung))) nil)
        (t (dolist (x (expansionen (first ableitung))(values))
             (print
              (apply #'parse-td/bf
                     (reduziere-bf* satz
				    (append x (rest ableitung))
				    (cons (cons (first ableitung) x)
					  struktur))))))))


(defun reduziere-bf* (satz ableitung struktur)
  (if (element_von-p (first satz) (first ableitung))
      (reduziere-bf* (rest satz)
	       (rest ableitung)
	       (cons `(,(first ableitung) ,(first satz)) struktur))
     `(,satz ,ableitung ,struktur)))
  
