;------------------------------------------------------------------------------
;
;               Tools fuer die top-down Parser
;
;------------------------------------------------------------------------------


;;;; Strukturgenerierung
;;;; -------------------

; Erzeuge aus einer Folge von Regeln eine Strukturbeschreibung
(defun transform (struktur)
  (do* ((listen struktur
                (replace-element
                       (replace-element (first listen)
                                        (length (member (caar listen)
                                                        (reverse liste)))
                                        liste)
                 (- (length listen)
                    (length (member liste listen :test #'equal)) )
                 (rest listen)))
        (liste (find-element (caar listen) (rest listen))
               (find-element (caar listen) (rest listen))))
       ((endp (rest listen)) (first listen))))


;;; FIND-ELEMENT findet die Liste, in der die andere Liste einzufuegen ist
(defun find-element (symbol list-of-lists)
  (dolist (x list-of-lists)
    (when (member symbol (rest x))
          (return x))))

;;; Ersetze zahl-tes Element in LISTE durch NEU
(defun replace-element (neu zahl liste)
  (if (< (length liste) zahl)
      liste
      (let ((resultat ())
            (zaehler 1))
        (dolist (x liste)
          (if (< zaehler zahl)
              (setf zaehler (+ zaehler 1)
                    resultat (append resultat (list x)))
              (return (append resultat (list neu) (nthcdr zaehler liste))))))))


